#! c:\perl\bin\perl.exe

use Win32::API::Prototype;

$OPEN_EXISTING = 3;
$GENERIC_READ  = 0x80000000;
$BACKUP_DATA   = 0x00000001;
$BACKUP_ALTERNATE_DATA = 0x00000004;

connapi();

$File = $ARGV[0];
$hFile = CreateFile( $File,
                       $GENERIC_READ,
                       0,
                       undef,
                       $OPEN_EXISTING,
                       0,
                       0 ) || die "Can not open the file '$File'\n";

if( 0 < $hFile )
  {
    my $iStreamCount = 0;
    my $pBytesRead = pack( "L", 0 );
    my $pContext = pack( "L", 0 );
    my $pStreamIDStruct = pack( "L5", 0,0,0,0,0,0 );

    while( BackupRead( $hFile,
                       $pStreamIDStruct,
                       length( $pStreamIDStruct ),
                       $pBytesRead,
                       0,
                       0,
                       $pContext ) )
    {

      my $BytesRead = unpack( "L", $pBytesRead );
      my %Stream;
      
      last if( 0 == $BytesRead );
      
      @Stream{ id, attributes,
               size_low, size_high,
               name_size } = unpack( "L5", $pStreamIDStruct );

      $StreamSize = MakeLargeInt( $Stream{size_low}, $Stream{size_high} );
      $iTotalSize += $StreamSize;
      ++$iStreamCount if (( $BACKUP_ALTERNATE_DATA == $Stream{id} ) || ( $BACKUP_DATA == $Stream{id} ));
      if( ! BackupSeek( $hFile,
                        $Stream{size_low},
                        $Stream{size_high},
                        $pSeekBytesLow,
                        $pSeekBytesHigh,
                        $pContext ) )
       {
        last;
       }
     }

     printf("%s;%s",$iStreamCount,FormatNumber($iTotalSize));
     BackupRead( $hFile, undef, 0, 0, 1, 0, $pContext );
     CloseHandle( $hFile );
 }

sub FormatNumber
 {
   my( $Num ) = @_;
   {} while( $Num =~ s/^(-?\d+)(\d{3})/$1,$2/ );
   return( $Num );
 }

sub MakeLargeInt
 {
   my( $Low, $High ) = @_;
   return( $High * ( 1 + 0xFFFFFFFF ) + $Low );
 }

sub connapi{
ApiLink( 'kernel32.dll',
         'HANDLE CreateFile( LPCTSTR pszPath,
                             DWORD dwAccess,
                             DWORD dwShareMode,
                             PVOID SecurityAttributes,
                             DWORD dwCreationDist,
                             DWORD dwFlags,
                             HANDLE hTemplate )' )
    || die "Can not locate CreateFile()";
ApiLink( 'kernel32.dll',
         'BOOL CloseHandle( HANDLE hFile )' )
    || die "Can not locate CloseHandle()";
ApiLink( 'kernel32.dll',
         'BOOL BackupRead( HANDLE hFile,
                           LPBYTE pBuffer,
                           DWORD dwBytesToRead,
                           LPDWORD pdwBytesRead,
                           BOOL bAbort,
                           BOOL bProcessSecurity,
                           LPVOID *ppContext)' )
    || die "Can not locate BackupRead()";
ApiLink( 'kernel32.dll',
         'BOOL BackupSeek( HANDLE hFile,
                           DWORD dwLowBytesToSeek,
                           DWORD dwHighBytesToSeek,
                           LPDWORD pdwLowByteSeeked,
                           LPDWORD pdwHighByteSeeked,
                           LPVOID *pContext )' )
    || die "Can not create BackupSeek()";
}
