#!c:\perl\bin\perl.exe

use Win32::Lanman;


$policy = "audit.cfg";
$fails = 0;

system("cls");
print "\n\nCheking Audit Policy on:";
if (open(ADTPLY,"$policy")) {
 while (<ADTPLY>) {
  my $line = $_;
  chomp $line;
  next if ($line =~ "#" || $line eq "");
  my $machine = (split(/\(/,$line))[0];
  my $aux = (split(/\(/,$line))[1];
  $aux = (split(/\)/,$aux))[0];
  my @audit = split(/,/,$aux);
  if ($#audit != 8) { die "Syntax error on $policy: line $.!\n";}
  &auditpol($machine,@audit);
 }
 ($fails == 0) ? print "\n\nAudit Policy successfully checked!!!\n":print "\n\nThere are events or errors to check!!!\n"
}
else {
      die "Can't open $policy: $!\n";
}
close($policy);
print "\n\nPress <RETURN> to continue...";
$_ = <STDIN>;


sub auditpol {
 my ($server,@audit) = @_;
 my (%info);
 my ($dirty) = 0;
 my (%hash) = ("AuditCategoryDetailedTracking" => "Process Tracking",
               "AuditCategoryAccountLogon" => "Account Logon",
               "AuditCategorySystem" => "Restart and Shutdown System",
               "AuditCategoryAccountManagement" => "User/Group Management",
               "AuditCategoryDirectoryServiceAccess" => "Dir. Service Access",
               "AuditCategoryObjectAccess" => "File and Object Access",
               "AuditCategoryPolicyChange" => "Security Policy Changes",
               "AuditCategoryLogon" => "Logon and Logoff",
               "AuditCategoryPrivilegeUse" => "Use of User Rights");

 my (%config) = ("AuditCategoryDetailedTracking" => $audit[0],
                 "AuditCategoryAccountLogon" => $audit[1],
                 "AuditCategorySystem" => $audit[2],
                 "AuditCategoryAccountManagement" => $audit[3],
                 "AuditCategoryDirectoryServiceAccess" => $audit[4],
                 "AuditCategoryObjectAccess" => $audit[5],
                 "AuditCategoryPolicyChange" => $audit[6],
                 "AuditCategoryLogon" => $audit[7],
                 "AuditCategoryPrivilegeUse" => $audit[8]);

 my (%settings) = (0 => "None",
                   1 => "Success",
                   2 => "Failure",
                   3 => "Success and Failure");


 print "\n\nSever: $server";
 if (Win32::Lanman::LsaQueryAuditEventsPolicy("\\\\$server",\%info)) {
  my $audit = $info{auditingmode};
  if (!$audit) {
   print "\n\n  Events Detected:\n";
   print "\tError: Auditing is NOT enabled!!!\n";
   $fails = 1;
  }
  else {
   my $options = $info{eventauditingoptions};
   foreach my $key (keys %hash) {
    if ($$options[&$key] != $config{$key}){
     if ($dirty == 0){
      print "\n\n  Events Detected:\n";
      $dirty = 1;
      $fails = 1;
     }
     print "\t$hash{$key} -> $settings{$$options[&$key]} <> $settings{$config{$key}}\n";
    }
   }
  }
  print " -> OK!" if ($dirty == 0);
 }
 else {
  print "\n\n  Events Detected:\n";
  print "\tError: ";
  print Win32::FormatMessage(Win32::Lanman::GetLastError());
  $fails = 1
 }
}