#! c:\perl\bin\perl.exe

use Digest::SHA1;

$rtime = time();
$result = "integrity-report_$rtime.txt";
$hashs = "hashs.db";
@label = ('File','Access Time','Modification Time','Creation Time','Size','Alternate Streams','Total Size','SHA-1 Hash');

my $base = hashsum($hashs);
unless (open (SUM, "$hashs.sum")) {
 print "Could not open sum file: $!\n";
 print "\n\n\nPress <RETURN> to continue....";
 $_ = <STDIN>;
 die "\n";
}

my $temp = (split(/\t/,<SUM>))[1];
if ($temp ne $base) {
 print "\nIntegrity check failed: Database hash sum don't match!\n";
 print "\n\n\nPress <RETURN> to continue....";
 $_ = <STDIN>;
 die;
}

unless (open (DB, "$hashs")) {
 print "Could not open hashs file: $!\n";
 print "\n\n\nPress <RETURN> to continue....";
 $_ = <STDIN>;
 die "\n";
}

unless (open (RPT, "> $result")) {
 print "Could not open report file: $!\n";
 print "\n\n\nPress <RETURN> to continue....";
 $_ = <STDIN>;
 die "\n";
}

system("cls");
my $dir = `cd`;  #mudar depois....
chomp $dir;
$rtime = localtime($rtime);

print "\n\n\n        Checking Hashs Database.....\n\n";
print RPT "\n------------------- Database Analysis Report -------------------\n\n";
print RPT "Base Directory: $dir\n";
print RPT "Hash file     : $hashs\n";
print RPT "Base SHA-1 Sum: $base\n";
print RPT "Date          : $rtime\n";
print RPT "Report File   : $result\n";
print RPT "----------------------------------------------------------------\n";

while (<DB>){
 $dirty = 0;
 $line = $_;
 chomp $line;
 @record = split /;/,$line;
 $file = $record[0];
 if (-e $file) {
  print RPT "\n\nFile: $file";
  if ($record[1] eq "ERR") {
   print RPT "\n\nEvents Detected ->";
   printf RPT "\n* Alert: File inaccessible early, but now I can read!!!";
   next;
  }
  my ($adsnum,$sizet) = split /;/, `adscount.pl \"$file\"`);
  $base = hashsum($file);
  my @macs = (lstat($file))[7..10];
  my @aux;
  @aux = ($file,$macs[1],$macs[2],$macs[3],$macs[0],$adsnum,$sizet,$base);
  for $i (0 .. $#record){
   if  ($aux[$i] ne $record[$i]){
    print RPT "\n\nEvents Detected ->" if ($dirty == 0);
    if ((0 < $i) && ($i <= 3)){
     $record[$i] = localtime($record[$i]);
     $aux[$i] = localtime($aux[$i]);
     printf RPT "\n%-17s: %-15s <> %-15s",$label[$i],$record[$i],$aux[$i];
    }
    else {
         printf RPT "\n%-17s: %-7s <> %-7s",$label[$i],$record[$i],$aux[$i];
    }
    $dirty = 1;
   }
  }
 }
 else {
      if ($record[1] ne "ERR") {
       print RPT "\n\nFile: $file";
       print RPT "\n\nEvents Detected ->";
       printf RPT "\n* Alert: File accessible early, but inaccessible in this time!!!";
       $dirty = 1;
      }
      else {print RPT "\n\nCAN'T OPEN $file...";}
 }
 if ($dirty == 0){print RPT " -> Ok!\n";}
 else { print RPT "\n";}
}
close(DB);
close(RP);
close(SUM);
&prnrpt;
print "\n\n\nPress <RETURN> to continue....";
$_ = <STDIN>;

sub hashsum {
  my ($file) = @_;
  open (FILE, "$file") || die "Can't open $file: $!";
  binmode(FILE);
  $digest = Digest::SHA1->new->addfile(*FILE)->hexdigest;
  return $digest;
}

sub prnrpt {
 open (RPT, "$result") || die "Could not open report file: $!\n";
 while (<RPT>) {
  print;
 }
 close(RPT);
}