#!c:\perl\bin\perl.exe

use strict(vars);
use Win32::TieRegistry(Delimiter=>"/");
use Win32::Shortcut;
use Digest::HMAC_SHA1;

my $rtime = time();
my $result = "startup-report_$rtime.txt";
my $start = "start.db";
my $me = Win32::NodeName;

unless (open (DB, "$start")) {
 print "Could not open $start file: $!\n";
 print "\n\n\nPress <RETURN> to continue....";
 $_ = <STDIN>;
 die "\n";
}

unless (open (RPT, "> $result")) {
 print "Could not open report file: $!\n";
 print "\n\n\nPress <RETURN> to continue....";
 $_ = <STDIN>;
 die "\n";
}

system("cls");
my $dir = `cd`;  #mudar depois....
chomp $dir;
$rtime = localtime($rtime);

print "\n\n\n        Checking Startup Database.....\n\n";
print RPT "\n------------------- Database Analysis Report -------------------\n\n";
print RPT "Base Directory  : $dir\n";
print RPT "Startup Database: $start\n";
print RPT "Base SHA-1 Sum  : \n";
print RPT "Date            : $rtime\n";
print RPT "Report File     : $result\n";
print RPT "----------------------------------------------------------------\n";

while (<DB>){
 my $line = $_;
 chomp $line;
 my @record = split /;/,$line;
 &chkvalue($me,@record) if ($record[1] eq "V");
 &chkkey(@record) if ($record[1] eq "K");
 &chklink($me,@record) if ($record[1] eq "L");
 &chkdir($me,@record) if ($record[1] eq "D");
}

close(DB);

sub chkdir {
 my ($me,@record) = @_;
 my @Dlabel = ('Machine','Type','Directory','MTime','CTime','Entries');
 my $dirty = 0;
 my $server = $record[0];
 if ($server ne $me) {
  my ($drive,$aux) = (split(/:/,$record[2]));
  $record[2] = "\\\\$server\\$drive\$$aux";
 }
 print "$record[2]\n";
 print RPT "Machine: $server  Directory: $record[2]";
 my ($m,$c) = (lstat($record[2]))[9..10];
 opendir(TGT, "$record[2]");
 my @files = readdir(TGT);
 closedir(TGT);
 my @temp = ($server,"D",$record[2],$m,$c,$#files);
 for my $i (3 .. $#record){
  if  ($temp[$i] ne $record[$i]){
   print RPT "\nEvents Detected ->" if ($dirty == 0);
   if ($i != 5){
    $record[$i] = localtime($record[$i]);
    $temp[$i] = localtime($temp[$i]);
    printf RPT "\n%-17s: %-15s <> %-15s",$Dlabel[$i],$record[$i],$temp[$i];
   }
   else {
    printf RPT "\n%-17s: %-7s <> %-7s",$Dlabel[$i],$record[$i],$temp[$i];
   }
   $dirty = 1;
  }
 }
 ($dirty) ? print RPT "\n\n" : print RPT " -> OK!!!\n";
}



sub chkvalue {
 my ($me,@record) = @_;
 my @Vlabel = ('Machine','Type','Hive','Registry Path','File Path','MTime','CTime','Alternate Streams','Total Size','SHA-1 HMAC');
 my $server = $record[0];
 if (($server ne $me) && ($record[4] ne "Undefined")) {
  my ($drive,$aux) = (split(/:/,$record[4]));
  $record[4] = "\\\\$server\\$drive\$$aux";
 }
 print "$record[4]\n";
 print RPT "Machine: $server  Value: $record[2]/$record[3]";
 my $dirty = 0;
 if (&readreg($server,$record[2],$record[3])) {
  my $base = hashsum($record[4]);
  my ($adsnum,$sizet) = split /;/, `adscount.pl \"$record[4]\"`;
  my ($m,$c) = (lstat($record[4]))[9..10];
  my @temp = ($server,$record[1],$record[2],$record[3],$record[4],$m,$c,$adsnum,$sizet,$base);
  for my $i (5 .. $#record){
   if  ($temp[$i] ne $record[$i]){
    print RPT "\nEvents Detected ->" if ($dirty == 0);
    if ((5 == $i) || ($i == 6)){
     $record[$i] = localtime($record[$i]);
     $temp[$i] = localtime($temp[$i]);
     printf RPT "\n%-17s: %-15s <> %-15s",$Vlabel[$i],$record[$i],$temp[$i];
    }
    else {
         printf RPT "\n%-17s: %-7s <> %-7s",$Vlabel[$i],$record[$i],$temp[$i];
    }
    $dirty = 1;
   }
  }
  ($dirty) ? print RPT "\n\n" : print RPT " -> OK!!!\n";
 }
 else {
  ($record[4] eq "Undefined") ?  print RPT " -> OK!!!\n" : print RPT "-> Erro\n";
 }
}

sub chkkey {
 my @record = @_;
 my @Klabel = ('Machine','Type','Hive','Registry Path','Values Count','Last Write Time');
 my $server = $record[0];
 my $dirty = 0;
 my ($valcnt,@lwrite) = split /;/, `keytime.pl $server \"$record[2]/$record[3]\"`;
 print RPT "Machine: $server  Key: $record[2]/$record[3]";
 if (@lwrite) {
  if ($valcnt != $record[4]) {
   print RPT "\n\nEvents Detected ->";
   printf RPT "\n%-17s: %-15s <> %-15s",$Klabel[4],$record[4],$valcnt;
   $dirty = 1;
  }
  my $aux = join(" ",@lwrite);
  my $aux1 = join(" ",@record[5..$#record]);
  if ($aux ne $aux1) {
   print RPT "\nEvents Detected ->" unless ($dirty);
   printf RPT "\n%-17s: %-15s <> %-15s",$Klabel[5],$aux1,$aux;
  }
  ($dirty) ? print RPT "\n\n" : print RPT " -> OK!!!\n";
 }
 else {
  ($record[4] eq "Undefined") ?  print RPT " -> OK!!!\n" : print RPT "-> ERROR <-\n";
 }
}

sub chklink {
 my ($me,@record) = @_;
 my $profiles;
 my @Llabel = ('Machine','Type','Directory','Link File','Link HMAC','Executable File','MTime','CTime','Alternate Streams','Total Size','SHA-1 HMAC');
 my $server = $record[0];
 my $dirty = 0;
 my $root = getsysdrivel($server);
 if (($server ne $me) && ($record[4] ne "Undefined")) {
  my ($drive,$aux) = (split(/:/,$record[5]));
  $record[5] = "\\\\$server\\$drive\$$aux";
  $profiles = "\\\\$server\\$root\$\\Documents and Settings\\";
 }
 else {
  $profiles = "$root:\\Documents and Settings\\";
 }
 print RPT "Machine: $server  Link: $record[2]\\$record[3]";
 my $link = $profiles.$record[2]."\\Start Menu\\Programs\\Startup\\".$record[3];
 print "$link\n";
 if ((-e $link)&&($record[4] ne "Undefined")) {
  my $shortcut = Win32::Shortcut->new($link);
  if ($shortcut) {
   my $basel = hashsum($link);
   my $xfile = $record[5];
   my $base = hashsum($xfile);
   my ($adsnum,$sizet) = split /;/, `adscount.pl \"$record[5]\"`;
   my ($m,$c) = (lstat($xfile))[9..10];
   my @temp = ($server,"L",$record[2],$link,$basel,$xfile,$m,$c,$adsnum,$sizet,$base);
   for my $i (4 .. $#record){
    if  ($temp[$i] ne $record[$i]){
     print RPT "\nEvents Detected ->" if ($dirty == 0);
     if ((6 == $i) || ($i == 7)){
      $record[$i] = localtime($record[$i]);
      $temp[$i] = localtime($temp[$i]);
      printf RPT "\n%-17s: %-15s <> %-15s",$Llabel[$i],$record[$i],$temp[$i];
     }
     else {
      printf RPT "\n%-17s: %-7s <> %-7s",$Llabel[$i],$record[$i],$temp[$i];
     }
     $dirty = 1;
    }
   }
   ($dirty) ? print RPT "\n\n" : print RPT " -> OK!!!\n";
  }
  else {
   print "Shortcut Problem....\n";
  }
 }
 else {
  ($record[4] eq "Undefined") ?  print RPT " -> OK!!!\n" : print RPT "-> Erro\n";
 }
}

sub readreg {
 my ($machine,$hive,$path) = @_;
 my ($remote,$result);
 if ($remote = $Registry->{"//$machine/$hive"}) {
  $result = $remote->{$path};
 }
 else {
  print "Can't connect with: //$machine/$hive\n";
  return;
 }
 print "Can't read: $hive/$path\n" if (!$result);
 return($result);
}

sub getsysdrivel {
 my ($server) = @_;
 my $rootdir = &readreg($server,'LMachine','SOFTWARE/Microsoft/Windows NT/CurrentVersion/SystemRoot');
 my $drivechar = (split(/:/,$rootdir))[0];
 return($drivechar);                      #return the drive letter
}

sub hashsum {
 my ($file) = @_;
 my $hkey = 123456;
 if (open (FILE, "$file")) {
  binmode(FILE);
  my $digest = Digest::HMAC_SHA1->new($hkey)->addfile(*FILE)->hexdigest;
  close (FILE);
  return $digest;
 }
 else {
   print "Can't open $file: $!\n";
   return("Undefined");
 }
}