#! c:\perl\bin\perl.exe

use strict(vars);
use Win32::TieRegistry(Delimiter=>"/");
use Win32::Shortcut;
use Digest::HMAC_SHA1;

my $me = Win32::NodeName;
my $table = "start.db";
my $policy = "audit.cfg";
my ($server,$aux,$line);

open (DB,"> $table") || die "Could not open $table: $!";

print "\n\t\tGenarating Startup Integrity Database\n\n";
print "Machines List   : $policy\n";
print "Startup Database: $table\n";
print "---------------------------------------------------------\n";


if (open(ADTPLY,"$policy")) {
 while (<ADTPLY>) {
  $line = $_;
  chomp $line;
  next if ($line =~ "#" || $line eq "");
  $server = (split(/\(/,$line))[0];
  print "Machine: $server\n\n";
  $aux = (split(/\(/,$line))[1];
  $aux = (split(/\)/,$aux))[0];
  my @audit = split(/,/,$aux);
  die "Syntax error on $policy: line $.!\n" if ($#audit != 8);

  $server = "\U$server";
  $me = "\U$me";
  if (&sysstart($server,$me)) {
  &userstart($server,$me);
  &chkdirs($server,$me);
  }
  else {
   print DB "$server;S;Error\n";
  }
  print "---------------------------------------------------------\n";
 }
}
else {
      die "Can't open $policy: $!\n";
}
close($policy);
close(DB);

sub addkey {
 my ($server,$hive,$rpath) = @_;
 my $timestr = `keytime.pl $server \"$hive/$rpath\"`;
 print DB "$server;K;$hive;$rpath;$timestr\n";
}

sub getTrojanKeys {
 my ($server,$me,$hive,$remote) = @_;
 my ($rpath) = 'SOFTWARE/Microsoft/Windows/CurrentVersion';
 my (@keys) = ('Run','RunOnce','RunOnceEx','RunServices');
 foreach my $k (@keys) {
  print "Checking Key: $hive/$rpath/$k\n\n";
  &addkey($server,$hive,"$rpath/$k");
  my $key = $remote->{"$rpath/$k"}; #&readreg($server,$hive,"$rpath/$k");
  if (defined $key) {
   my @vals = $key->ValueNames;
   if($#vals != -1) {
    foreach my $val (@vals) {
     my $data = $key->{$val};
     $data = "NotFound" unless($data);
     #print "  - $k:$val:$data\n";
     my @files = &namesynt($server,$me,$data);
     foreach my $file (@files) {
      #print "File: $file\n";
      my $base = hashsum($file);
      my $adsnum = `adscount.pl \"$file\"`;
      my ($m,$c) = (lstat($file))[9..10];
      if ($server ne $me) {
       my @temp = split(/\\/,$file);
       my $drive = $temp[3];
       $drive =~ s/\$/:\\/g;
       $file = join("\\",@temp[4..$#temp]);
       $file = $drive.$file;
      }
      print "> $file -> $base\n";
      print DB "$server;V;$hive;$rpath/$k/$val;$file;$m;$c;$adsnum;$base\n";
     }
    }
   }
  }
 }
}


sub hashsum {
 my ($file) = @_;
 my $hkey = 123456;
 if (open (FILE, "$file")) {
  binmode(FILE);
  my $digest = Digest::HMAC_SHA1->new($hkey)->addfile(*FILE)->hexdigest;
  close (FILE);
  return $digest;
 }
 else {
   print "Can't open $file: $!\n";
   return("Undefined");
 }
}

sub recognize {
 my ($c) = @_;
 return(1) if ((($c eq "RUNDLL") || ($c eq "RUNDLL.EXE")) || (($c eq "RUNDLL32") || ($c eq "RUNDLL32.EXE")));
 return(1) if ($c eq "START");
 return(1) if (($c eq "CMD") || ($c eq "CMD.EXE"));
 return(1) if ((($c eq "WSCRIPT") || ($c eq "CSCRIPT")) || (($c eq "WSCRIPT.EXE") || ($c eq "CSCRIPT.EXE")));
 return(0);
}

sub namesynt {
 my ($server,$me,$brute) = @_;
 my ($aux,$final,$drive,$startdir,@temp,@files);
 my (@ext,@spath);
 my $e;

 if (($brute =~ /^\"/ ) && ($brute =~ /\"$/ )){
  @temp = split(/\"/,$brute);
  $brute = join("\"",@temp[1..$#temp]);
 }
 #print "Brute: $brute\n";
 $aux = `parser.pl \"$brute\"`;             #parse line...
 my @targets = split(/;/,$aux);
 #print "Targets: ".join("-",@targets)."\n";
 foreach my $target (@targets) {
  @temp = split(/\\/,$target);
  next if (((!$#temp) && ($target eq $targets[0])) && recognize($temp[$#temp]));
  $aux = $temp[$#temp];

  if (!$#temp) {
   if ($aux =~ /./) {
    #print "Aux: $aux\n";
    @spath = &getspath($server);
    foreach my $sp (@spath) {
     ($drive,$sp) = split(/:/,$sp);
     #print "$sp\n";
     if ($server eq $me){
      $startdir = "$drive:";
     }
     else {
      $startdir = "\\\\$server\\$drive\$";
     }
     $sp = $sp."\\" if !($sp =~ /\\$/);
     $final = $startdir.$sp.$target;
     #print "Searching: ".$final."\n";
     last if (-e $final);
    }
   }
   else {
    @ext = &getext($server);
    @spath = &getspath($server);
    foreach my $sp (@spath) {
     ($drive,$sp) = split(/:/,$sp);
     if ($server eq $me){
      $startdir = "$drive:";
     }
     else {
      $startdir = "\\\\$server\\$drive\$";
     }
     $sp = $sp."\\" if !($sp =~ /\\$/);
     foreach $e (@ext) {
      $final = $sp.$target.$e;
      #print "Searching: ".$startdir.$final."\n";
      last if (-e $startdir.$final);
     }
     last if (-e $startdir.$final);
    }
   }
  }
  else {
   ($drive,$aux) = split(/:/,$target);
   if ($server eq $me) {
    $startdir = "$drive:";
   }
   else { $startdir = "\\\\$server\\$drive\$"; }
   #print "Startdir: $startdir\n";
   $final = $startdir.$aux;
  }
  push(@files,$final);
 # print "Final: $final\n";
 }
 return(@files);
}

sub chkdirs {
 my ($server,$me) = @_;

 print "\n- Checking Startup Directories\n\n";
 my ($startdir,$drivechar,$xdir,$drive,@temp);
 $drivechar = &getsysdrivel($server);
 if ($server eq $me) {
  $startdir = "$drivechar:";
 }
 else {
  $startdir = "\\\\$server\\$drivechar\$";
 }
 my $start = $startdir."\\Documents and Settings";
 my $startup = "\\start menu\\programs\\startup";
 my ($dir,$err);
 if (-e $start && -d $start) {
  opendir(ST,"$start");
  my @files = readdir(ST);
  rewinddir(ST);
  my ($m,$c) = (lstat($start))[9..10];
  if ($server ne $me) {
   @temp = split(/\\/,$start);
   $drive = $temp[3];
   $drive =~ s/\$/:\\/g;
   $xdir = join("\\",@temp[4..$#temp]);
   $xdir = $drive.$xdir;
  }
  else {
   $xdir = $start;
  }
  print DB "$server;D;$xdir;$m;$c;$#files\n";
  foreach $dir (sort readdir(ST)) {
   next if ($dir eq "." || $dir eq "..");
   my $dir2 = $start."\\".$dir;
   if (-e $dir2 && -d $dir2) {
    my $newdir = "$start\\".$dir."$startup";
    if (-e $newdir && -d $newdir) {
     opendir(SUP,$newdir);
     @files = readdir(SUP);
     closedir(SUP);
     ($m,$c) = (lstat($newdir))[9..10];
     if ($server ne $me) {
      @temp = split(/\\/,$newdir);
      $drive = $temp[3];
      $drive =~ s/\$/:\\/g;
      $xdir = join("\\",@temp[4..$#temp]);
      $xdir = $drive.$xdir;
     }
     else { $xdir = $newdir; }
     print DB "$server;D;$xdir;$m;$c;$#files\n";
     print "Cheking: $xdir\n";
     if (@files) {
      foreach my $file (@files) {
       next if ($file eq "." || $file eq "..");
       if ($file =~ m/lnk$/) {
        my $shortcut = Win32::Shortcut->new($newdir."\\".$file);
        my $basel = hashsum($newdir."\\".$file);
        if ($shortcut) {
         my $data = $shortcut->{Path};
         #print "$dir:$file:$data\n";
         my @xfiles = &namesynt($server,$me,$data);
         foreach my $xfile (@xfiles) {
          my $base = hashsum($xfile);
          my $adsnum = `adscount.pl \"$xfile\"`;
          ($m,$c) = (lstat($xfile))[9..10];
          if ($server ne $me) {
           my @temp = split(/\\/,$xfile);
           my $drive = $temp[3];
           $drive =~ s/\$/:\\/g;
           $xfile = join("\\",@temp[4..$#temp]);
           $xfile = $drive.$xfile;
          }
          print DB "$server;L;$dir;$file;$basel;$xfile;$m;$c;$adsnum;$base\n";
          print "> $xfile -> $base\n";
         }
        }
        else {
         print "Error with Shortcut: ".Win32::FormatMessage Win32::GetLastError."\n";
         print DB "$server;L;$dir;$file;Undefined\n";
        }
       }
       else {
        print "$dir:$file\n";
       }
      }
     }
    }
    else {
     print "$newdir does not exist or is not a directory.\n";
    }
   }
  else {
   print "$dir2 does not exist or is not a directory.\n";
  }
 }
 closedir(ST);
 }
 else {
  print "$start does not exist or is not a directory.\n";
 }
}

sub sysstart {
 my ($server,$me) = @_;

 my %rkeys = ("UserInit" => "SOFTWARE/Microsoft/Windows NT/CurrentVersion/Winlogon/UserInit",
              "Load" => "SOFTWARE/Microsoft/Windows NT/CurrentVersion/Windows/Load");
 my ($file);
 my $remote = &conn_hive($server,'LMachine');
 return(0) unless ($remote);
 foreach my $k (keys %rkeys) {
  my $reg = $rkeys{$k};
  #print "$reg\n";
  my $data = $remote->{$reg};
  #print "$k : $data\n";
  my ($drive,@files,@temp);
  if (defined $data) {
   @files = &namesynt($server,$me,$data);
   foreach $file (@files) {
    #print "File: $file\n";
    my $base = hashsum($file);
    my $adsnum = `adscount.pl \"$file\"`;
    my ($m,$c) = (lstat($file))[9..10];
    if ($server ne $me) {
     @temp = split(/\\/,$file);
     $drive = $temp[3];
     $drive =~ s/\$/:\\/g;
     $file = join("\\",@temp[4..$#temp]);
     $file = $drive.$file;
    }
    print DB "$server;V;LMachine;$reg;$file;$m;$c;$adsnum;$base\n"; #server;type;hive;path;program;mtime;ctime;nads;sizet;hash
   }
  }
  else { print DB "$server;V;LMachine;$reg;Undefined\n"; }
 }
 return(1);
}

sub userstart {
 my ($server,$me) = @_;

 my %hives = ("LMachine" => "HKLM",
              "CUser" => "HKCU");
 my ($remote);

 foreach my $hive (keys %hives) {
  $remote = &conn_hive($server,$hive);
  next unless ($remote);
  &getTrojanKeys($server,$me,$hive,$remote);
 }
}

sub getsysdrivel {
 my ($server) = @_;
 my $rootdir = &readreg($server,'LMachine','SOFTWARE/Microsoft/Windows NT/CurrentVersion/SystemRoot');
 my $drivechar = (split(/:/,$rootdir))[0];
 return($drivechar);                      #return the drive letter
}

sub getext {
 my ($server,$remote) = @_;
 my $data = &readreg($server,'LMachine','SYSTEM/CurrentControlSet/Control/Session Manager/Environment/PATHEXT');
 my @extensions = split(/;/,$data);
 return (@extensions);
}

sub getspath {
 my ($server) = @_;
 my $data = &readreg($server,'LMachine','SYSTEM/CurrentControlSet/Control/Session Manager/Environment/Path');
 my @dirs = split(/;/,$data);
 foreach my $i (0..$#dirs) {
  $dirs[$i] = &expand($server,$dirs[$i]);
 }
 return(@dirs);                          #return list of path dirs
}

sub readreg{
 my ($machine,$hive,$path) = @_;
 my ($remote,$result);
 if ($remote = $Registry->{"//$machine/$hive"}) {
  $result = $remote->{$path};
 }
 else {
  print "Can't connect with: //$machine/$hive\n";
  return;
 }
 print "Can't read: $hive/$path\n" if (!$result);
 return($result);
}

sub conn_hive {
 my ($machine,$hive) = @_;
 my ($remote);
 if ($remote = $Registry->{"//$machine/$hive"}) {
  return($remote);
 }
 else {
  print "Can't connect with: //$machine/$hive\n";
  return;
 }
}

sub expand {
 my ($server,$path) = @_;
 my $systemroot = &readreg($server,'LMachine','SOFTWARE/Microsoft/Windows NT/CurrentVersion/SystemRoot');
 my $ProgramFilesDir = &readreg($server,'LMachine','SOFTWARE/Microsoft/Windows/CurrentVersion/ProgramFilesDir');
 $path =~ s/%systemroot%/$systemroot/gi;
 $path =~ s/%ProgramFilesDir%/$ProgramFilesDir/gi;
 $path =~ s/%ProgramFilesPath%/$ProgramFilesDir/gi;
 return ($path);
}