use strict;
use Win32::API;
use Win32::TieRegistry(Delimiter=>"/");

my @month = qw/Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec/;
my @day = qw/Sun Mon Tue Wed Thu Fri Sat/;

my $server = $ARGV[0];#Win32::NodeName;
my $regkey = $ARGV[1] || die "You must enter a Registry key.\n";
$regkey =~ s/\\/\//g;
my $remote = $Registry->{"//$server/".$regkey};
if (!$remote){
 print "Undefined";
 exit
}
my %info;

if (%info = $remote->Information) {

my $FileTimeToLocalFileTime = new Win32::API('kernel32', 'FileTimeToLocalFileTime', ['P', 'P'], 'I');
my $FileTimeToSystemTime =  new Win32::API('kernel32', 'FileTimeToSystemTime', ['P', 'P'], 'I');

my $number =  $info{'CntValues'};
my $pFileTime = $info{'LastWrite'};
my $lpLocalFileTime;
my $pSystemTime = pack("S8",0);

# Translate the FILETIME to LOCALFILETIME
if ($FileTimeToLocalFileTime->Call($pFileTime,$lpLocalFileTime)) {


        if ($FileTimeToSystemTime->Call($lpLocalFileTime,$pSystemTime)) {

# Unpack the 8 WORD values from the system time structure....
# year,month,dayofweek,day,hour,minute,sec,milli
          my @time = unpack("S8", $pSystemTime);
#
          $time[5] = "0".$time[5] if ($time[5] =~ m/^\d$/);
          $time[6] = "0".$time[6] if ($time[6] =~ m/^\d$/);
          my $timestr = $number.";".$day[$time[2]].";".$time[1]."/".$time[3]."/".$time[0].
                ";".$time[4]."-".$time[5]."-".$time[6]."-".$time[7];
          print "$timestr";

                  }
}
}
else {
 print "Undefined";
 }