#!c:\perl\bin\perl.exe

use Win32::Lanman;

my $policy = "audit.cfg";
my ($line,$machine,$aux,@audit);
$dirty = 0;

system("cls");
print "\nSetting Audit Policy on:\n";
if (open(ADTPLY,"$policy")) {
 while (<ADTPLY>) {
  $line = $_;
  chomp $line;
  next if ($line =~ "#" || $line eq "");
  $machine = (split(/\(/,$line))[0];
  $aux = (split(/\(/,$line))[1];
  $aux = (split(/\)/,$aux))[0];
  @audit = split(/,/,$aux);
  if ($#audit != 8) { die "Syntax error on $policy: line $.!\n";}
   &setting($machine,@audit);
 }
}
else {
      die "Can't open $policy: $!\n";
}
close($policy);
($dirty == 0) ? print "\nAudit Policy successfully configured!!!\n":print "\nThere were errors during the configuration!!!\n";
print "\n\nPress <RETURN> to continue...";
$_ = <STDIN>;


sub setting {

 my ($server,@audit) = @_;

 my (%info,@options);
 my @macros = (&POLICY_AUDIT_EVENT_NONE,&POLICY_AUDIT_EVENT_SUCCESS,&POLICY_AUDIT_EVENT_FAILURE,
                &POLICY_AUDIT_EVENT_SUCCESS | &POLICY_AUDIT_EVENT_FAILURE,&POLICY_AUDIT_EVENT_UNCHANGED);

 print "\n$server -> @audit";


 $options[AuditCategoryDetailedTracking] = $macros[$audit[0]];
 $options[AuditCategoryAccountLogon] = $macros[$audit[1]];
 $options[AuditCategorySystem] = $macros[$audit[2]];
 $options[AuditCategoryAccountManagement] = $macros[$audit[3]];
 $options[AuditCategoryDirectoryServiceAccess] = $macros[$audit[4]];
 $options[AuditCategoryObjectAccess] = $macros[$audit[5]];
 $options[AuditCategoryPolicyChange] = $macros[$audit[6]];
 $options[AuditCategoryLogon] = $macros[$audit[7]];
 $options[AuditCategoryPrivilegeUse] = $macros[$audit[8]];

 %info = ('auditingmode' => 1,                  # turn on auditing
          'eventauditingoptions' => \@options );

 if(!Win32::Lanman::LsaSetAuditEventsPolicy("\\\\$server", \%info)){
  print "\tFAIL!\n";
  print "Error: ";
  print Win32::FormatMessage(Win32::Lanman::GetLastError());
  $dirty = 1;
 }
 else { print "\tOK!\n";}
}